
	.export		NMI_main

	.include	"sample.inc"


.segment	"LOWCODE"
;===============================================================
;			nmi_main(void);
;---------------------------------------------------------------
;	Summary :		NMI main Routine
;	Arguments :		None
;	Return :		None
;	Modifies :		None
;	Useage :		Please write this address to interrupt vector
;---------------------------------------------------------------
;	st
;	ENMI荞݂́APPU֘Ȃɂ
;	@PPUւ̃ANZX́AAҒɂłȂ߁B
;	EL[̓ǂݍ݂ANMI荞݂ōsB
;	@L[ǂݍݒɉhCo[荞ނƁAL[ǂݍ݂Ɏs邽߁B
;===============================================================
.proc	NMI_main

;---------------------------------------
;register push
;---------------------------------------
	pha
	tya
	pha
	txa
	pha

;---------------------------------------
;call the callback routine
;---------------------------------------

	;---------------
	;VRAMXVR[ȟďo
;	lda	_NMI_CallBack + 1
;	beq	CallBack_Ret
;	jsr	jmp_NMI_CallBack

CallBack_Ret:

;---------------------------------------
; Call sound driver main routine
;---------------------------------------

	;---------------
	;TEhhCoďo

	jsr	_nsd_main

;---------------------------------------
; Read joy-pad
;---------------------------------------

Key:
	;---------------
	;ÕL[Rs[
	lda	__PAD0
	sta	__PAD0_OLD
	lda	__PAD1
	sta	__PAD1_OLD

	;---------------
	;ϐ
	ldx	#$01
	stx	__PAD0
	stx	__PAD1
	stx	__n0
	stx	__n1
	stx	__n2
	stx	__n3

	;---------------
	;Pړǂݍ
	stx	APU_PAD1	;4021 P/S_CONTROL[q <= High (PARALLEL operation)
	dex
	stx	APU_PAD1	;4021 P/S_CONTROL[q <= Low  (SERIAL   operation)

@loop1:
	lda	APU_PAD1
	lsr	a
	rol	__n0		;PAD1
	lsr	a
	rol	__n2		;PAD3igPADj

	lda	APU_PAD2
	lsr	a
	rol	__n1		;PAD2
	bcc	@loop1

	;---------------
	;Qړǂݍ	iPCM  `^OɂmCŶ߁j
	inx
	stx	APU_PAD1	;4021 P/S_CONTROL[q <= High (PARALLEL operation)
	dex
	stx	APU_PAD1	;4021 P/S_CONTROL[q <= Low  (SERIAL   operation)

@loop2:
	lda	APU_PAD1
	lsr	a
	rol	__PAD0		;PAD1
	lsr	a
	rol	__n3		;PAD3igPADj

	lda	APU_PAD2
	lsr	a
	rol	__PAD1		;PAD2
	bcc	@loop2

	;---------------
	;PCM  `^ÕmCY  オE茟o

	;-------
	;PAD3igPADj
	lda	__n3
	and	__n2		;mCYiPځAQڋ`H'̏ꍇɁA`H'j
	sta	__n2

	;-------
	;PAD1 & PAD3
	lda	__n0
	and	__PAD0		;mCYiPځAQڋ`H'̏ꍇɁA`H'j
	ora	__n2		;PAD3igPADj̓ǂݍ݂APAD1Ƀ}[W
	sta	__PAD0

	eor	__PAD0_OLD	;GbWo
	tax
	and	__PAD0
	sta	__PAD0_TRG	;オ
	txa
	and	__PAD0_OLD
	sta	__PAD0_REL	;

	;-------
	;PAD2
	lda	__n1
	and	__PAD1		;mCYiPځAQڋ`H'̏ꍇɁA`H'j
	sta	__PAD1

	eor	__PAD1_OLD	;GbWo
	tax
	and	__PAD1
	sta	__PAD1_TRG	;オ
	txa
	and	__PAD1_OLD
	sta	__PAD1_REL	;



;---------------------------------------
; Count-up
;---------------------------------------
Count:
@cc:
	inc	__cc
	lda	__cc
	cmp	#60
	bne	@exit
	lda	#0
	sta	__cc

@ss:
	ldx	__ss
	cpx	#$59
	beq	@ss_1
	inx
	stx	__ss
	txa
	and	#$0F
	cmp	#$0A
	bne	@exit
	txa
	add	#6
	sta	__ss
	bne	@exit
@ss_1:
	lda	#0
	sta	__ss

@mm:
	ldx	__mm
	cpx	#$59
	beq	@mm_1
	inx
	stx	__mm
	txa
	and	#$0F
	cmp	#$0A
	bne	@exit
	txa
	add	#6
	sta	__mm
	bne	@exit
@mm_1:
	lda	#0
	sta	__mm

@hh:
	inc	__hh

@exit:

;---------------------------------------
;register pop
;---------------------------------------
	pla
	tax
	pla
	tay
	pla

	rti
.endproc

.proc	jmp_NMI_CallBack
	jmp	(_NMI_CallBack)
.endproc

