/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#include "StdAfx.h"
#include "DPCM.h"

/****************************************************************/
/*					O[oϐiNXǁEEEj		*/
/****************************************************************/
extern	OPSW*			cOptionSW;	//IvVւ̃|C^ϐ

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		FileInput*			DPCMfile	PCMi*.dmcj̃t@C
//					size_t	_id			ԍ
//		const		_CHAR	_strName[]	̃IuWFNg̖O
//	Ԓl
//					
//==============================================================
DPCM::DPCM(MMLfile* MML, const char* dmcfile, size_t _id, const _CHAR _strName[]):
	MusicItem(_id, _strName),
	_DPCM_size(0)
{
	fileopen(dmcfile, &cOptionSW->m_pass_dmc);

	if(f_error == true){
		string	errMsg = "\"";
		errMsg += dmcfile;
		errMsg += "\" :";
		errMsg += strerror(errno);
		MML->Err(errMsg);
	} else {
		//----------------------
		//Localϐ
		std::streamsize	_size	= GetSize();

		if(_size > 0x0FF1){
			MML->Warning(_T("PCM̃t@CTCY傫܂B4081ByteɃJbg܂B"));
			iSize = 0x0FF1;
			_size = 0x0FF1;
		} else {
			if((_size & 0x000F) != 0x01){
				iSize = (_size & 0x0FF0) + 0x0011;
			} else {
				iSize = _size;
			}
		}
		_DPCM_size = (unsigned char)(iSize >> 4);

		code.resize(iSize);

		//PCM̂]
		read((char*)code.c_str(), _size);

		//Padding
		for(size_t i = _size; i<iSize; i++){
			code[i] = (unsigned char)0xAA;
		}
		close();
	}
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
DPCM::~DPCM(void)
{
}

//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//		MusicFile*	MUS		R[ho͂ȃf[^t@CEIuWFNg
//	Ԓl
//				
//==============================================================
void	DPCM::getAsm(MusicFile* MUS)
{
	*MUS << ".align	$40\n" << MUS->Header.Label.c_str() << "DPCM" << m_id << ":" << endl;
	MusicItem::getAsm(MUS);
}
