/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#pragma once

/****************************************************************/
/*																*/
/*			萔`											*/
/*																*/
/****************************************************************/
typedef	struct {
		string				name;
		size_t				line;
} Macro_Stack;

/****************************************************************/
/*																*/
/*			NX`											*/
/*																*/
/****************************************************************/
class MMLfile	// :
//	public FileInput
{
//o[ϐ
private:
				string				nowCommand;			//݃RpC̃R}h
	vector	<	FileInput*	>		ptcFiles;			//MMLt@C
				FileInput*			nowFile;			//݂̃t@C
				size_t				iFiles;				//݂̃t@CNo.

	map		< string,		string>	ptcMac;				//Macro̕ۑ
	map		< string,		int>	lv_Mac;				//Macro̊Kw

	vector	<	Macro_Stack	>		s_macro;			//lXg̃}NX^bN
				Macro_Stack			nowMacro;
				size_t				p_macro;			//lXgځH

				bool				f_macro;			//}NIɗtO
				bool				f_2to1;				//}`oCgϊH
				bool				f_error;			//G[̗L
public:
	map		<	size_t,	Patch*>		ptcPatch;			//Patch

				size_t				offset_Ei;			//
				size_t				offset_Ev;			//
				size_t				offset_En;			//
				size_t				offset_Em;			//
				int					iReleaseVolume;		//
				int					iRepeatMode;		//
				int					iTieMode;			//
				int					timebase;			//
				bool				octave_reverse;		//Octave Reverse
				bool				q_reverse;			//q, Q q_reverse
				int					rest;				// r R}h̋
				int					wait;				// w R}h̋
	unsigned	int					QMax;				// qMax
	unsigned	char				priority;

//o[֐
public:
	MMLfile(string&	strFileName);
	~MMLfile(void);

				bool	eof(void);				//݂̃t@CEOF`FbN
				bool	eom(void);				//llk̏I`FbN

				void	include();				//|C^ɂt@C#include
	
				void	SetMacro(int i_Lv);
				void	DeleteMacro(int i_Lv);
				void	CallMacro(void);
				size_t	GetMacroNest(void){return(p_macro);};

				void	SetPatch(void);
				bool	ChkPatch(size_t _no);

	fstream::pos_type	tellg(void);					//݂̃t@C̃|C^擾
				void	StreamPointerMove(fstream::pos_type iSize);	//݂̃t@C̃|C^ړ
private:		void	Back_one(void);					//1߂
public:			void	Back(void);						//1߂iSpEpϊΉj

private:		char	read_char(void);				//1Byteǂݍ
public:			char	cRead(void);					//1Byteǂݍ݁iSpEpϊΉj
				char	GetChar(void);					//1Byteǂݍ݁iwith EOF & Commend checkj
				void	ChkBlockStart(void);					//'{'܂Ń|C^i߂
				void	ChkEOF(void);							//[EOF]`FbN
				bool	GetChar_With_ChkEOF(char* cData);		//1Byteǂݍ '}'`FbNt
				void	GetString(string* _str, bool f_ESC);	//""t  ǂݍ
				int		GetNum(void);					//()t  l  ǂݍ
				int		GetInt(void);					//lǂݍ
				bool	chkSigh(void);					//`FbN
				int		GetHex(void);					//16iǂݍ
				int		GetDec(void);					//10iǂݍ
				int		GetOct(void);					// 8iǂݍ
				int		GetBin(void);					// 2iǂݍ
				int		GetLength(int DefaultLength);	//ǂݍ݁iZtj
				int		readLength(int DefaultLength);	//ǂݍ

				int		GetCommandID(const Command_Info _command[], size_t _size);	//R}hID擾

				size_t	GetLine(void){return(nowFile->GetLine());};
				void	SetLine(size_t i){nowFile->SetLine(i);};

				void	ErrUnknownCmd();
				void	Err(const _CHAR msg[]);
				void	Warning(const _CHAR msg[]);
				void	Err(const string& str);
				void	Warning(const string& str);

				bool	isError(){return(f_error);};
};
