/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#include "StdAfx.h"
#include "SearchPass.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//					
//	Ԓl
//					
//==============================================================
SearchPass::SearchPass(void):
	m_count(0)
{
	
}

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//					
//	Ԓl
//					
//==============================================================
SearchPass::~SearchPass(void)
{
	clear();
}

//==============================================================
//		o^̑SNA
//--------------------------------------------------------------
//	
//					
//	Ԓl
//					
//==============================================================
void		SearchPass::clear()
{
	//----------------------
	//Delete Class

	//pXSB
	for(map<size_t,string>::iterator it=m_ptcPass.begin(), e=m_ptcPass.end(); it!=e; ++it){
		it->second.clear();
	}
	m_ptcPass.clear();
	m_count	= 0;
}

//==============================================================
//		fobOpo
//--------------------------------------------------------------
//	
//					
//	Ԓl
//					
//==============================================================
void		SearchPass::debug()
{
	//----------------------
	//Delete Class

	//pẌꗗo
	for(map<size_t,string>::iterator it=m_ptcPass.begin(), e=m_ptcPass.end(); it!=e; ++it){
		cout << it->second.c_str() << endl;
	}
}

//==============================================================
//		o^Pǉi/\ꍇAŕt^j
//--------------------------------------------------------------
//	
//		string*	_str	o^錟pX
//	Ԓl
//					
//==============================================================
void		SearchPass::add_one(string* _str)
{
	size_t	i	= _str->size();
	char	c;

	if(_str->empty() == false){
		c = (*_str)[i-1];
		if((c != '/') && (c != '\\')){
			(*_str) += "/";
		}
		m_ptcPass[m_count].assign(*_str);
		m_count++;
		_str->clear();
	}
}

//==============================================================
//		o^̒ǉ with ";"ɂ镡o^Ή
//--------------------------------------------------------------
//	
//		char*	_str	o^錟pX	';'ŋ؂΁Ao^
//	Ԓl
//					
//==============================================================
void		SearchPass::add(char*	_str)
{
	//----------------------
	//Localϐ
	size_t	i = 0;
	string	strTemp;

	if(_str != NULL){
		strTemp.clear();

		while(_str[i] != 0){
			switch(_str[i]){
				case(_PATH_SPLIT):
					add_one(&strTemp);
					break;
				default:
					strTemp	+= _str[i];
					break;
			}
			i++;
		}
		add_one(&strTemp);
	}
}

//==============================================================
//		o^̒ǉ with ";"ɂ镡o^Ή
//--------------------------------------------------------------
//	
//		string*	_str	o^錟pX	';'ŋ؂΁Ao^
//	Ԓl
//					
//==============================================================
void		SearchPass::add(string*	_str)
{

	//----------------------
	//Localϐ
	size_t	i = 0;
	string	strTemp;

	strTemp.clear();
	_str->append(1, _PATH_SPLIT);

	while(i < _str->size()){
		switch((*_str)[i]){
			case(_PATH_SPLIT):
				add_one(&strTemp);
				break;
			default:
				strTemp	+= (*_str)[i];
				break;
		}
		i++;
	}
}

//==============================================================
//		pX̎擾
//--------------------------------------------------------------
//	
//		size_t id		o^ԍ
//		string*			pX
//	Ԓl
//		int				0			
//						ȊO	ُ
//==============================================================
const char*	SearchPass::get(size_t id)
{
	return(m_ptcPass[id].c_str());
}
