/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#include "StdAfx.h"
#include "mml_repeat.h"

//==============================================================
//		RXgN^ifor Repert Aj
//--------------------------------------------------------------
//	
//		const		char	_strName[]	NX̖O
//		unsigned	char	count		s[g
//	Ԓl
//				
//==============================================================
mml_repeat::mml_repeat(size_t _id, unsigned char count, const _CHAR _strName[]):
	MusicEvent(_id, _strName)
{
	iSize = 2;
	code.resize(iSize);
	code[0] = nsd_Repeat_A_Start;
	code[1] = count;
}

//==============================================================
//		RXgN^ifor Repert Bj
//--------------------------------------------------------------
//	
//		const		char	_strName[]	NX̖O
//	Ԓl
//				
//==============================================================
mml_repeat::mml_repeat(size_t _id, const _CHAR _strName[]):
	MusicEvent(_id, _strName)
{
	iSize = 1;
	code.resize(iSize);
	code[0] = nsd_Repeat_B_Start;
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
mml_repeat::~mml_repeat(void)
{
}

//==============================================================
//		񐔐ݒ
//--------------------------------------------------------------
//	
//		unsigned	char	count	s[g
//	Ԓl
//				
//==============================================================
void	mml_repeat::set_count(unsigned char count)
{
	if(	iSize != 2){
		throw invalid_argument("mml_repeat::set_count()");
	}
	code[1] = count;
}
//==============================================================
//		񐔐ݒ
//--------------------------------------------------------------
//	
//				
//	Ԓl
//		unsigned	char	count	s[g
//==============================================================
unsigned	char	mml_repeat::get_count(void)
{
	unsigned	char	count;

	if(	iSize != 2){
		throw invalid_argument("mml_repeat::get_count()");
	}
	count = code[1];
	return(count);
}
