/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#include "StdAfx.h"
#include "Envelop.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MMLfile*			MML			MMLt@C̃IuWFNg
//					size_t	_id			Gx[vԍ
//		const		_CHAR	_strName[]	IuWFNg
//	Ԓl
//					
//==============================================================
Envelop::Envelop(MMLfile* MML, size_t _id, const _CHAR _strName[]):
	MusicItem(_id, _strName)
{
	//----------------------
	//Localϐ


//	萔`
enum	Command_ID_mml {
	Env_Num,
	Env_Sweep,
	Env_Hold,
	Env_Loop,
	Env_Release,
	Env_Commma
};

//	́AMML\ŎgR}hB
const	static	Command_Info	Command[] = {
		{	"$",	Env_Num		},
		{	"%",	Env_Num		},
		{	"-",	Env_Num		},
		{	"0",	Env_Num		},
		{	"1",	Env_Num		},
		{	"2",	Env_Num		},
		{	"3",	Env_Num		},
		{	"4",	Env_Num		},
		{	"5",	Env_Num		},
		{	"6",	Env_Num		},
		{	"7",	Env_Num		},
		{	"8",	Env_Num		},
		{	"9",	Env_Num		},
		{	"{",	Env_Sweep	},
		{	"(",	Env_Sweep	},
		{	"d",	Env_Hold	},
		{	"D",	Env_Hold	},
		{	"",	Env_Hold	},
		{	"c",	Env_Hold	},
		{	"|",	Env_Loop	},
		{	"b",	Env_Loop	},
		{	"l",	Env_Loop	},
		{	"L",	Env_Loop	},
		{	"",	Env_Loop	},
		{	"k",	Env_Loop	},
		{	"r",	Env_Release	},
		{	"R",	Env_Release	},
		{	"",	Env_Release	},
		{	"q",	Env_Release	},
		{	"@",	Env_Commma	},
		{	"C",	Env_Commma	},
		{	"A",	Env_Commma	},
		{	",",	Env_Commma	}
};

				char	cData;
				int		i;

				int		iValue	=255;	//̐ݒl
				int		iLength	=0;		//OXkp

	//------------------------------
	//NX̏ݒ

	Loop_Normal		= -1;
	Loop_Release	= -1;
	Release			= false;
	ptEnvelop		= 1;

	code.resize(0);
	code.append((char)1, (char)0);



	//------------------------------
	//RpC

	// { ̌
	MML->ChkBlockStart();

	// } ܂ŁALqubNRpCB
	while(MML->GetChar_With_ChkEOF(&cData)){

		//P߂
		MML->Back();

		//eR}h̏
		switch(MML->GetCommandID(Command, sizeof(Command)/sizeof(Command_Info))){

			case(Env_Num):
				MML->Back();
				i = MML->GetInt();
				if( (i<-64) || (i>127)){
					MML->Err(_T("Gx[v-64`127͈̔͂Ŏw肵ĉB"));
				}

				if(iValue == i){
					iLength++;		//AOXk
				} else {
					if(iLength>0){
						setHold(iLength-1);	//܂ł̎ԂZB
						iLength	= 0;		//OXk
					}
					iValue	= i;

					code.append((char)1, (char)i & 0x7F);
					ptEnvelop++;
				}
				break;

			case(Env_Sweep):
				if(iLength>0){
					setHold(iLength-1);
					iLength	= 0;	//OXk
				}
				iValue = sweep(MML);
				break;

			case(Env_Hold):
				i = MML->GetInt();
				if( (i<0) || (i>255)){
					MML->Err(_T("ێԂ0`255͈̔͂Ŏw肵ĉB"));
				}
			//	setHold(i + iLength);	//܂ł̎ԂZB
				iLength += i+1;			//OXɉZB
				break;

			case(Env_Loop):
				iValue	=255;			//OXk
				if(iLength>0){
					setHold(iLength-1);	//z[hԏo
					iLength	= 0;		//OXk
				}
				if(Release == false){
					if(ptEnvelop > 0x3F){
						MML->Warning(_T("[vʒuwł͈(64Byte)𒴂܂B"));
					}
					Loop_Normal		= ptEnvelop;
				} else {
					if(ptEnvelop > 0x3F){
						MML->Warning(_T("[X̃[vʒuwł͈(64Byte)𒴂܂B"));
					}
					Loop_Release	= ptEnvelop;
				}
				break;

			case(Env_Release):
				iValue	=255;			//OXk
				if(iLength>0){
					setHold(iLength-1);	//z[hԏo
					iLength	= 0;		//OXk
				}
				SetLoop(MML, Loop_Normal);
				code[0] = (unsigned char)ptEnvelop;
				Release = true;
				break;

			case(Env_Commma):
				break;

			//unknown command
			default:
				MML->ErrUnknownCmd();
				break;
		}
	}

	iValue	=255;			//OXk
	if(iLength>0){
		setHold(iLength-1);	//z[hԏo
		iLength	= 0;		//OXk
	}

	if(Release == true){
		SetLoop(MML, Loop_Release);
	} else {
		SetLoop(MML, Loop_Normal);
	}

	if(code.size() > 256){
		MML->Err(_T("Gx[v̒`255Bytez܂B"));
	}

	iSize = code.size();
}

void Envelop::SetLoop(MMLfile* MML, int LoopPoint)
{
	if(LoopPoint == -1){
		if(Release == true){
			MML->Warning(_T("[X̃[v|Cg܂BŌ̒l[v܂B"));
			if(ptEnvelop > 0x3F){
				MML->Warning(_T("[X̃[vʒuwł͈(63Byte)𒴂܂B"));
			}
		} else {
			MML->Warning(_T("[v|Cg܂BŌ̒l[v܂B"));
			if(ptEnvelop > 0x3F){
				MML->Warning(_T("[vʒuwł͈(63Byte)𒴂܂B"));
			}
		}
		code.append((char)1, (char)((ptEnvelop-1) | 0xC0));
	} else {
		if(ptEnvelop == Loop_Normal){
			MML->Err(_T("LR}hŃp^[`I邱Ƃ͂ł܂B"));
		}
		code.append((char)1, (char)(LoopPoint | 0xC0));
	}
	ptEnvelop++;
}
//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
Envelop::~Envelop(void)
{
}

//==============================================================
//		ێԂ̃Zbg
//--------------------------------------------------------------
//	
//		int		length		ێ
//	Ԓl
//				
//==============================================================
void	Envelop::setHold(int length)
{
	while(length>15){
		code.append((char)1, (unsigned char)0x8F);
		ptEnvelop++;
		length -= 16;		//15΁A16t[ێ
	}
	code.append((char)1, (char)((length & 0x0F) | 0x80));
	ptEnvelop++;
}

//==============================================================
//		XC[v
//--------------------------------------------------------------
//	
//		MMLfile*	MML		MMLt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
int	Envelop::sweep(MMLfile* MML)
{
	unsigned	char	cData;

	int		iStart;
	int		iEnd;
	int		iLength;
	int		iDelta;

	int		now	= 0;
	int		cnt	= 0;

	int		i=0;
	int		temp;

	//--------------------------
	//MMLǂݍ

	//
	iStart = MML->GetInt();
	if( (iStart<-64) || (iStart>127)){
		MML->Err(_T("Jn_-64`127͈̔͂Ŏw肵ĉB"));
	}

	cData = MML->GetChar();
	if(cData != ','){
		MML->Err(_T("p[^܂B"));
	}

	iEnd = MML->GetInt();
	if( (iEnd<-64) || (iEnd>127)){
		MML->Err(_T("I_-64`127͈̔͂Ŏw肵ĉB"));
	}

	cData = MML->GetChar();
	if(cData != ','){
		MML->Err(_T("p[^܂B"));
	}

	iLength = MML->GetInt();
	if( (iLength<1) || (iLength>255)){
		MML->Err(_T("1`255͈̔͂Ŏw肵ĉB"));
	}

	cData = MML->GetChar();
	if((cData != ')') && (cData != '}')){
		MML->Err(_T(") ܂łB"));
	}

	//--------------------------
	//e[u쐬

	iDelta = iEnd - iStart;

	while(i<iLength){
		temp = iStart + (iDelta * i) / iLength;
		if(i == 0){
			now = temp;
			cnt	= 0;
		} else if (temp != now){
			code.append((char)1, (char)now & 0x7F);
			ptEnvelop++;
			if(cnt>=1){
				setHold(cnt-1);
			}
			now = temp;
			cnt	= 0;
		} else {
			cnt++;
		}
		i++;
	}

	code.append((char)1, (char)now & 0x7F);
	ptEnvelop++;
	if(cnt>=1){
		setHold(cnt-1);
	}
	return(now);
}

//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//		MusicFile*	MUS		R[ho͂ȃf[^t@CEIuWFNg
//	Ԓl
//				
//==============================================================
void	Envelop::getAsm(MusicFile* MUS)
{
	*MUS << MUS->Header.Label.c_str() << "Envelope" << m_id << ":" << endl;
	MusicItem::getAsm(MUS);
}
