/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#include "StdAfx.h"
#include "FileInput.h"

/****************************************************************/
/*					O[oϐiNXǁEEEj		*/
/****************************************************************/
extern	OPSW*			cOptionSW;	//IvVւ̃|C^ϐ

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
FileInput::FileInput(void):
	f_error(false),
	nowLine(1),
	readData(0)
{
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
FileInput::~FileInput(void)
{
}

//--------------------------------
//t@CJ@G[t
//--------------------------------
void	FileInput::fileopen(const char*	_strFileName){

	errno = 0;	//O[oϐ errno Oɏ
	clear();	//tÕNA

	open(_strFileName,ios_base::in | ios_base::binary);
	if(good()==false){
		f_error	= true;
	}
	strFilename.append(_strFileName);
};

//--------------------------------
//t@CJ@G[t
//--------------------------------
void	FileInput::fileopen(const char*	_strFileName,SearchPass* _pass)
{
	f_error	= true;

	//悸́Â܂
	errno = 0;	//O[oϐ errno Oɏ
	clear();	//tÕNA
	open(_strFileName,ios_base::in | ios_base::binary);
	if(cOptionSW->flag_SearchPass){
		perror(_strFileName);
	}

	if(good()==true){
		f_error	= false;
	} else {

		//pX
		size_t	iSize	= _pass->count();
		string	name;
		string	workName= string(_strFileName);
		size_t	loc		= workName.rfind('/');

		//w̃t@CɃpXĂAB
		if(loc != string::npos){
			workName.erase(0, loc);		//t@Ĉ
		}

		for(size_t i=0; i<iSize; ++i){

#ifdef _WIN32
			//Windows̏ꍇ́A΃pX܂߂ČiUNIXn͕sj
			//w̌pXƂ΃pXB
			errno = 0;	//O[oϐ errno Oɏ
			clear();	//tÕNA

			name.assign(_pass->get(i));
			name.append(_strFileName);
			open(name.c_str(),ios_base::in | ios_base::binary);
			if(cOptionSW->flag_SearchPass){
				perror(name.c_str());
			}
			if(good()==true){
				f_error	= false;
				break;
			};
#endif
			//WINDOWS, UNIXn
			//pX{t@Ĉ݂ŌB
			errno = 0;	//O[oϐ errno Oɏ
			clear();	//tÕNA

			name.assign(_pass->get(i));
			name.append(workName);
			open(name.c_str(),ios_base::in | ios_base::binary);
			if(cOptionSW->flag_SearchPass){
				perror(name.c_str());
			}
			if(good()==true){
				f_error	= false;
				break;
			};
		};
	};

	if(f_error == false){
		strFilename.append(_strFileName);	
	}
}

//--------------------------------
//΃V[N
//--------------------------------
void	FileInput::StreamPointerAdd(fstream::off_type iSize){
	seekg(iSize,ios::cur);
};

//--------------------------------
//΃V[N
//--------------------------------
void	FileInput::StreamPointerMove(fstream::pos_type iSize){
	seekg(iSize);
};

//--------------------------------
//1Byte߂
//--------------------------------
void	FileInput::Back(void)
{
	StreamPointerAdd(-1);
	if(readData == 0x0A){
		nowLine--;
	}

	//XV
	read((char*)&readData, sizeof(unsigned char));
	StreamPointerAdd(-1);
}

//--------------------------------
//1Byteǂݍ
//--------------------------------
unsigned	char	FileInput::cRead()
{
	read((char*)&readData, sizeof(unsigned char));
	if(readData == 0x0A){
		nowLine++;
	}

	return(readData);
};

//--------------------------------
//TCY
//--------------------------------
std::streamsize	FileInput::GetSize(){

	std::streamsize	szData;
	fstream::pos_type	iDataT = tellg();

	seekg(0		,ios::end);
	szData = tellg();
	seekg(iDataT);

	return(szData);
};
