/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#include "StdAfx.h"
#include "Option.h"


#ifdef _WIN32
// WINDOWŜ݁A'/'ɑΉB
#define OPTCHK (argv[iCount][0]=='/')||(argv[iCount][0]=='-')
#else
// unixnł̓XbV̓fBNg̋؂ɎgׁAs鎖
#define OPTCHK (argv[iCount][0]=='-')
#endif

//==============================================================
//		IvV
//--------------------------------------------------------------
//	
//			int		argc	IvV̐
//			_TCHAR*	argv[]	IvV
//	Ԓl
//			
//	l
//			IvVɃt@Cw肳Ȃꍇ́Awv\ďI
//==============================================================
OPSW::OPSW(int argc, char* argv[]):
	//ݒ
	fOptionError(false),
	fHelp(false),			//wv́AftHg͕\ȂB
	fErr(false),
	saveNSF(false),
	saveNSFe(false),
	saveASM(false),
	flag_Optimize(false),
	flag_OptObj(true),
	flag_OptSeq(true),
	flag_SearchPass(false),
	iNSF_version(2),
	iDebug(0)
{

	try {

		//----------------------------------
		//Local ϐ
		
		int		iCount = 1;			//whilẽJEgpiR}h͔΂j
		int		iResult;			//ėp

		//Optionp
		int		iOptionChk;			//IvV`FbNp@|C^
		char	cOption;			//IvV`FbNp@
		char	iFlagFilnameExt;	//gq̃tO

		//pX
		string	str_code	= "";
		string	str_dmc		= "";
		string	str_inc		= "";

		//----------------------------------
		//IvV
		while(iCount!=argc)
		{
			//--------------
			//IvVXCb`ɃnCt(orXbV)邩mF
			if(OPTCHK){

				//--------------
				//Option Switch	iXbVꍇ̏j
				switch(argv[iCount][1]){
					//--------
					//Help\
					case 'h' :
					case 'H' :
					case '?' :
						fHelp=true;
						break;
					//--------
					//œKݒ
					case 'o' :
					case 'O' :
						{
							bool fTemp;
							switch(argv[iCount][3]){
								case '0' :
								case '+' :
									fTemp = true;
									break;
								case '1' :
								case '-' :
									fTemp = false;
									break;
								default :
									throw string(argv[iCount]);
									break;
							}
							switch(argv[iCount][2]){
								case 'd' :
								case 'D' :
									flag_Optimize = fTemp;
									break;
								case 'o' :
								case 'O' :
									flag_OptObj = fTemp;
									break;
								case 's' :
								case 'S' :
									flag_OptSeq = fTemp;
									break;
								default :
									throw string(argv[iCount]);
									break;
							}
							break;
						}
					//--------
					//AZu
					case 'a' :
					case 'A' :
						saveASM = true;
						break;
					//--------
					//mre
					case 'n' :
					case 'N' :
						saveNSF = true;
						break;
					//--------
					//NSFe
					case 'x' :
					case 'X' :
						saveNSFe = true;
						break;
					//--------
					//WG[o͂
					case 'e' :
					case 'E' :
						fErr = true;
						break;
					//--------
					//mre
					case 'v' :
					case 'V' :
						switch(argv[iCount][2]){
							case 0x00 :
							case '1' :
								iNSF_version = 1;
								break;
							case '2' :
								iNSF_version = 2;
								break;
							default :
								throw string(argv[iCount]);
								break;
						}
						break;
					//--------
					//Tick Count
			//		case 't' :
			//		case 'T' :
			//			flag_TickCount = false;
			//			break;
					//--------
					//Search Pass
					case 's' :
					case 'S' :
						flag_SearchPass = true;
						break;
					//--------
					//Debug̎w
					case 'D' :
						//0x01:	Phase [1] : Creating Class Object process
						//0x10:	Phase [2] : Optimizing process
						//0x20:	Phase [3] : Setting Address
						//0x40:	Phase [4] : Outputing Music File
						//0x80:	Phase [5] : Delete Class Object
						int	i;
						iResult=sscanf(argv[iCount],"-D%d",&i);
						iDebug = i;
						if((iResult==0)||(iResult==EOF)){
							throw string(argv[iCount]);
							break;
						};
						break;
					//--------
					//Debug̎w
					case 'l' :
					case 'L' :
						//Ɏw肳ĂH
						if(strCodeName.empty()){
							iFlagFilnameExt=0;		//gq̗L@Reset
							iOptionChk=0;
							while((cOption=argv[iCount][iOptionChk+2])!=0)
							{
								strCodeName+=cOption;
								if(cOption=='.'){iFlagFilnameExt=1;};
								iOptionChk++;
							};
							if(iFlagFilnameExt==0){
								strCodeName+=".bin";
							};
						} else {
							throw _T("-l Code t@C2ȏw肳܂B");
							break;
						};
						break;
					//--------
					//ROMR[ȟpX
					case 'c' :
					case 'C' :
						str_code += &argv[iCount][2];
						str_code.append(1, _PATH_SPLIT);
						break;
					//--------
					//PCM̌pX
					case 'p' :
					case 'P' :
						str_dmc += &argv[iCount][2];
						str_dmc.append(1, _PATH_SPLIT);
						break;
					//--------
					//CN[ht@ČpX
					case 'i' :
					case 'I' :
						str_inc += &argv[iCount][2];
						str_inc.append(1, _PATH_SPLIT);
						break;
					//--------
					//t@C̎w
					case 'f' :
					case 'F' :
						//ɁAt@CĂ邩`FbNB
						if(argv[iCount][3]==0){
							throw _T("-f t@CĂ܂B");
							break;
						};
						switch(argv[iCount][2]){
						//--------
						//Assemblyt@C̎w
						case 'A' :
						case 'a' :
							//Ɏw肳ĂH
							if(strASMname.empty()){
								iFlagFilnameExt=0;		//gq̗L@Reset
								iOptionChk=0;
								while((cOption=argv[iCount][iOptionChk+3])!=0)
								{
									strASMname+=cOption;
									if(cOption=='.'){iFlagFilnameExt=1;};
									iOptionChk++;
								};
								if(iFlagFilnameExt==0){
									strASMname+=".s";
								};
							} else {
								throw _T("-fa ASM t@C2ȏw肳܂B");
								break;
							};
							break;
						//--------
						//NSFt@C̎w
						case 'N' :
						case 'n' :
							//Ɏw肳ĂH
							if(strNSFname.empty()){
								iFlagFilnameExt=0;		//gq̗L@Reset
								iOptionChk=0;
								while((cOption=argv[iCount][iOptionChk+3])!=0)
								{
									strNSFname+=cOption;
									if(cOption=='.'){iFlagFilnameExt=1;};
									iOptionChk++;
								};
								if(iFlagFilnameExt==0){
									strNSFname+=".nsf";
								};
							} else {
								throw _T("-fn NSF t@C2ȏw肳܂B");
								break;
							};
							break;
						//--------
						//NSFet@C̎w
						case 'X' :
						case 'x' :
							//Ɏw肳ĂH
							if(strNSFename.empty()){
								iFlagFilnameExt=0;		//gq̗L@Reset
								iOptionChk=0;
								while((cOption=argv[iCount][iOptionChk+3])!=0)
								{
									strNSFename+=cOption;
									if(cOption=='.'){iFlagFilnameExt=1;};
									iOptionChk++;
								};
								if(iFlagFilnameExt==0){
									strNSFename+=".nsfe";
								};
							} else {
								throw _T("-fn NSFe t@C2ȏw肳܂B");
								break;
							};
							break;
						default :
							throw string(argv[iCount]);
							break;
						};
					break;
					//--------
					//ftHg
					default :
						throw string(argv[iCount]);
						break;
				};

			} else{

				//--------------
				//t@C	iXbVꍇ̏j
				//Ɏw肳ĂH
				if(strMMLname.empty()){
					iFlagFilnameExt=0;		//gq̗L@Reset
					iOptionChk=0;		
					while((cOption=argv[iCount][iOptionChk])!=0)
					{
						strMMLname+=cOption;
						if(cOption=='.'){iFlagFilnameExt=1;};
						iOptionChk++;
					};
					if(iFlagFilnameExt==0){
						strMMLname+=".mml";
					};
				} else {
					throw _T("MMLt@C2ȏw肳܂B");
					break;
				};

			};

			//--------------
			//̃IvV
			iCount++;
		};

		//----------------------------------
		//IvVŎw肳ꂽB

		//--------------
		//wv\
		//t@CȂꍇAwv\B
		if((fHelp==true)||(strMMLname.empty())){print_help();};

		if(strASMname.empty()){
			iOptionChk=0;		
			while((cOption=strMMLname[iOptionChk])!='.')
			{
				strASMname+=cOption;
				iOptionChk++;
			};
			strASMname+=".s";
		};

		if(strNSFname.empty()){
			iOptionChk=0;		
			while((cOption=strMMLname[iOptionChk])!='.')
			{
				strNSFname+=cOption;
				iOptionChk++;
			};
			strNSFname+=".nsf";
		};

		if(strNSFename.empty()){
			iOptionChk=0;		
			while((cOption=strMMLname[iOptionChk])!='.')
			{
				strNSFename+=cOption;
				iOptionChk++;
			};
			strNSFename+=".nsfe";
		};

		//----------------------------------
		//pX̐ݒ

		//MML̃fBNg擾
		iResult	= 0;
		for(iCount=0; iCount<(int)strMMLname.size(); ++iCount){
			if((strMMLname[iCount] == '\\') || (strMMLname[iCount] == '/')){
				iResult = iCount;
			}
		}

		//D揇ʂP@JgpX
		//D揇ʂQ@MMLt@C݂pX
		if(iResult > 0){
			string	str_mmldir = "";
			for(iCount=0; iCount<iResult; ++iCount){
				str_mmldir += strMMLname[iCount];
			}
			m_pass_code.add(&str_mmldir);
			m_pass_dmc.add(&str_mmldir);
			m_pass_inc.add(&str_mmldir);
		}

		//D揇ʂR@ϐŎw̃pX
		m_pass_code.add(getenv("PATH"));
		m_pass_dmc.add(getenv("DMC_INCLUDE"));

		//D揇ʂS@IvVŎw̃pX
		m_pass_code.add(&str_code);
		m_pass_dmc.add(&str_dmc);
		m_pass_inc.add(&str_inc);



		//----------------------------------
		//

		//	to do	̑̃IvVǉƂ́A̕ӂɒǋLB

		//----------
		//Debugp \
	//	cout << "MML = " << strMMLname << endl;
	//	cout << "NSF = " << strNSFname << endl;
	//	cout << "NSFe = " << strNSFename << endl;
	//	cout << "BIN = " << strBINname << endl;
	//	cout << "ASM = " << strASMname << endl;
	//	cout << "C   = " << strCname << endl;

	/*
		cout << "code:" << endl;
		m_pass_code.debug();

		cout << "dmc:" << endl;
		m_pass_dmc.debug();

		cout << "inc:" << endl;
		m_pass_inc.debug();
	*/

	} catch (int no) {
		if (no != EXIT_SUCCESS){
			nsc_ErrMsg(no);
		}
		fOptionError = true;	//IvVŃG[B
	} catch (const exception& e){
		nsc_ErrMsg(e);
		fOptionError = true;	//IvVŃG[B
	} catch (const _CHAR *stErrMsg) {
		if(fErr == true){
			_CERR	<<	_T("IvVsłBF") << stErrMsg << endl;
		} else {
			_COUT	<<	_T("IvVsłBF") << stErrMsg << endl;
		}
		fOptionError = true;	//IvVŃG[B
	} catch (const string& str) {
		if(fErr == true){
			_CERR	<<	_T("IvVsłBF");
			cerr	<<	str.c_str() << endl;
		} else {
			_COUT	<<	_T("IvVsłBF");
			cout	<<	str.c_str() << endl;
		}
		fOptionError = true;	//IvVŃG[B
	}
};

//==============================================================
//		fXgNg
//--------------------------------------------------------------
//	
//			Ȃ
//	Ԓl
//			
//==============================================================
OPSW::~OPSW(){

};

//==============================================================
//		wvbZ[W
//--------------------------------------------------------------
//	
//			Ȃ
//	Ԓl
//			
//==============================================================
void	OPSW::print_help(){

	_COUT	<<	_T("MML Compiler for NES Sound Driver & Library\n")
				_T("\n")
				_T("  Usage : nsc [ -options ] [file(.mml)]\n")
				_T("\n")
				_T("  -A			Compile to assembly langage.\n")
				_T("  -N			Compile to NSF music format.\n")
				_T("  -X			Compile to NSFe music format.\n")
				_T("  -V[num]		Specify the NSF Version.\n")
			//	_T("  -T			Disable to output the tick counting result.\n")
				_T("  -Od[+/-]		Optimize the NSF bank struct of the delta-PCM.\n")
				_T("  -Oo[+/-]		Optimize the object data.\n")
				_T("  -Os[+/-]		Optimize the sequence data.\n")
				_T("  -E			Error/Warning messages out the stadard error.\n")
				_T("  -S			Enable outout the search pass result.\n")
				_T("  -L[file(.bin)]	Filename of the rom code for NSF.\n")
				_T("  -FA[file(.s  )]	Filename of the output assembly langage file.\n")
				_T("  -FN[file(.nsf)]	Filename of the output NSF music format.\n")
				_T("  -FX[file(.nsfe)]	Filename of the output NSFe music format.\n")
				_T("  -C[dir]		Search pass of the rom code for NSF.\n")
				_T("  -P[dir]		Search pass of the delta-pcm.\n")
				_T("  -I[dir]		Search pass of the include file.\n")
				_T("  -H			Print the this help.")	<<	endl;

	throw EXIT_SUCCESS;
};
