/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#pragma once

/****************************************************************/
/*																*/
/*			NX`											*/
/*																*/
/****************************************************************/

#define	DEBUG_Create		0x01	//0x01:	Phase [1] : Creating Class Object process
#define DEBUG_Meta_Create	0x02	//0x02:	Phase [1] : Outputing Music File
#define DEBUG_Macros		0x04	//0x04:	Phase [1] : Debug for Macro, Patch
#define	DEBUG_Optimize		0x08	//0x08:	Phase [2] : Optimizing process
#define	DEBUG_SetAddress	0x10	//0x10:	Phase [3] : Setting Address
#define	DEBUG_Meta_Set		0x20	//0x20:	Phase [3] : Setting Address
#define	DEBUG_FixAddress	0x40	//0x10:	Phase [3] : Fix Address
#define	DEBUG_Delete		0x100	//0x40:	Phase [5] : Delete Class Object
#define DEBUG_Meta_Delete	0x200	//0x80:	Phase [5] : Delete Class Object
#define DEBUG_Close_Inc		0x400	//0x100:Phase [5] : Close Include File


/****************************************************************/
/*																*/
/*			NX`											*/
/*																*/
/****************************************************************/
class OPSW {
//o[ϐ
public:
				bool		fOptionError;	//IvVŃG[ꍇ
				bool		fHelp;			//wvw肵H
				bool		fErr;			//G[o͐	true:WG[ó^false:Wo
				bool		saveNSF;		//.nsf o͂邩
				bool		saveNSFe;		//.nsfeo͂邩
				bool		saveASM;		//.s   o͂邩
				bool		flag_Optimize;	//œKLɂ邩H
				bool		flag_OptObj;	//œKLɂ邩H
				bool		flag_OptSeq;	//œKLɂ邩H
		//		bool		flag_TickCount;	//TickCount𖳌ɂ邩H
				bool		flag_SearchPass;//SearchPass̏ʂo͂邩
				int			iNSF_version;	//NSF̃@[W

	unsigned	int			iDebug;			//fobOp
				string		strMMLname;		//w肵MMLt@C
				string		strNSFname;		//w肵NSFt@C
				string		strNSFename;	//w肵NSFet@C
				string		strASMname;		//w肵ASMt@C
				string		strCodeName;	//ROM Code̖O

				SearchPass	m_pass_code;	//pX	".bin"t@C
				SearchPass	m_pass_dmc;		//pX	".dmc"t@C
				SearchPass	m_pass_inc;		//pX	CN[ht@C

//o[֐
public:
						OPSW();								//̂
						OPSW(int argc, char* argv[]);		//eANXt@CI[v
						~OPSW();							//t@CN[Y

				bool	isError(){return(fOptionError);};
private:
				void	print_help();						//help message
};
