/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

// ÓIf
#include "StdAfx.h"
#include "Sub.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MMLfile*	MML			MMLt@C̃IuWFNg
//		size_t		_id			Tu[`ԍ
//		const _CHAR	_strName[]	IuWFNg
//	Ԓl
//					
//==============================================================
Sub::Sub(MMLfile* MML, size_t _id, const _CHAR _strName[]/* = "==== [ Sub ]===="*/):
	TrackSet(MML, _id, true, false, _strName)
{
	_OMP_INIT_LOCK(lock_TickCount)
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
Sub::~Sub()
{
	_OMP_DESTROY_LOCK(lock_TickCount)
}

//==============================================================
//		TickCount	Tu[`Ăяo
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
unsigned	int	Sub::TickCount(MusicFile* MUS, NSD_WORK* work)
{
	int	_iResult;

	//̃gbNĂяoĂ鎞ɁAȂB
	_OMP_SET_LOCK(lock_TickCount)
	_iResult = ptcTrack[0]->TickCount(MUS, work);
	_OMP_UNSET_LOCK(lock_TickCount)

	return(_iResult);
}

//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//		MusicFile* MUS		R[ho͂ȃf[^t@CEIuWFNg
//	Ԓl
//				
//==============================================================
void	Sub::getAsm(MusicFile* MUS)
{
	*MUS << MUS->Header.Label.c_str() << "SUB" << m_id << ":" << endl;
	TrackSet::getAsm(MUS);
}
